Subject: bug#8600: closed (Merged fixes for 8600, 8601, 8602, and (partially) for 8545)

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 06 May 2011 07:31:02 +0000

Your bug report

#8600: struct charset.code_space[15] contains garbage

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
8600: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=8600
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Merged fixes for 8600, 8601, 8602, and (partially) for 8545
From: Paul Eggert <[email-masked]>
To: [email-masked], [email-masked], [email-masked], [email-masked]
Date: Fri, 06 May 2011 00:29:56 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

I committed to the Emacs trunk a merge (bzr 104134) that has fixes for
the following bugs:

* Bug#8600 - The fix removes the garbage element of code_space.

* Bug#8601 - Here I assumed that the "* 2" is a typo.

* Bug#8602 - This fixes some large-int-to-float screwups in
             the Lisp reader.

* Bug#8545 - This fixes the bug where the code should have called
             va_copy, but didn't.  Also, I changed a limit so that
	     the MOST_POSITIVE_FIXNUM limit for strings applies to
	     their length, i.e., does not include the null termination
	     byte.  Stefan hasn't had time to chime in, but if this
             last change turns out to be incorrect I will back it out.

This merge doesn't entirely fix Bug#8545, so I'll leave that bug open;
the others I'll close.

Subject: struct charset.code_space[15] contains garbage
From: Paul Eggert <[email-masked]>
To: [email-masked]
Date: Sun, 01 May 2011 09:59:25 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

While testing the 32+64 port I noticed that a too-wide value
is stuffed into charset.code_space[15], which means that
slot has a garbage value (at least, it's garbage on typical
machines with 32-bit int).  As far as I can see, the garbage
value is never used, so it's a bit cleaner to never compute
or store it.

I plan to install the following patch to do that.
This patch is relevant to ordinary 32- and 64-bit hosts, too,
so I'm separating it out.

* charset.h (struct charset.code_space): Now has 15 elements, not 16.
* charset.c (Fdefine_charset_internal): Don't initialize
charset.code_space[15].  The value was garbage, on hosts with
32-bit int.
=== modified file 'src/charset.c'
--- src/charset.c	2011-04-26 06:17:52 +0000
+++ src/charset.c	2011-05-01 06:28:23 +0000
@@ -869,7 +869,7 @@
   ASET (attrs, charset_name, args[charset_arg_name]);

   val = args[charset_arg_code_space];
-  for (i = 0, dimension = 0, nchars = 1; i < 4; i++)
+  for (i = 0, dimension = 0, nchars = 1; ; i++)
     {
       int min_byte, max_byte;

@@ -880,10 +880,12 @@
       charset.code_space[i * 4] = min_byte;
       charset.code_space[i * 4 + 1] = max_byte;
       charset.code_space[i * 4 + 2] = max_byte - min_byte + 1;
+      if (max_byte > 0)
+	dimension = i + 1;
+      if (i == 3)
+	break;
       nchars *= charset.code_space[i * 4 + 2];
       charset.code_space[i * 4 + 3] = nchars;
-      if (max_byte > 0)
-	dimension = i + 1;
     }

   val = args[charset_arg_dimension];

=== modified file 'src/charset.h'
--- src/charset.h	2011-04-11 06:48:18 +0000
+++ src/charset.h	2011-05-01 16:22:33 +0000
@@ -155,10 +155,11 @@
      byte code of the (N+1)th dimension, <code_space>[4N+1] is a
      maximum byte code of the (N+1)th dimension, <code_space>[4N+2] is
      (<code_space>[4N+1] - <code_space>[4N] + 1), <code_space>[4N+3]
-     is a number of characters containd in the first to (N+1)th
-     dismesions.  We get `char-index' of a `code-point' from this
+     is the number of characters contained in the first through (N+1)th
+     dimensions, except that there is no <code_space>[15].
+     We get `char-index' of a `code-point' from this
      information.  */
-  int code_space[16];
+  int code_space[15];

   /* If B is a byte of Nth dimension of a code-point, the (N-1)th bit
      of code_space_mask[B] is set.  This array is used to quickly